package nstatus

import (
	"git.noahlan.cn/noahlan/ntool-biz/core/nstatus/code"
)

/**
API错误，用于返回带HTTP状态码的错误返回信息
*/

// NewApiErr 构建Api错误，code为http状态码
func NewApiErr(code int, message string) error {
	return NewResult(code, message, ApiErr)
}

// NewApiErrNoMsg 构建Api错误，空错误消息
func NewApiErrNoMsg(code int) error {
	return NewApiErr(code, "")
}

func NewApiInternalErr(msg string) error {
	return NewApiErr(code.StatusInternalServerError, msg)
}

func NewApiBadRequestErr(msg string) error {
	return NewApiErr(code.StatusBadRequest, msg)
}

func NewApiUnauthorizedErr(msg string) error {
	return NewApiErr(code.StatusUnauthorized, msg)
}

func NewApiForbiddenErr(msg string) error {
	return NewApiErr(code.StatusForbidden, msg)
}

func NewApiNotFoundErr(msg string) error {
	return NewApiErr(code.StatusNotFound, msg)
}

func NewApiBadGatewayErr(msg string) error {
	return NewApiErr(code.StatusBadGateway, msg)
}
