package types

import (
	"git.noahlan.cn/noahlan/ntool/narr"
	"git.noahlan.cn/noahlan/ntool/nlog"
)

type Gender string

const (
	GenderSecure Gender = "Secure" // 保密
	GenderMale   Gender = "Male"   // 男
	GenderFemale Gender = "Female" // 女
)

var genderVals = []string{
	string(GenderSecure),
	string(GenderMale),
	string(GenderFemale),
}

func (Gender) Values() (kinds []string) {
	kinds = genderVals
	return
}

func (g Gender) String() string {
	return string(g)
}

func ParseGender(str string) Gender {
	if narr.StringsHas(genderVals, str) {
		return Gender(str)
	}
	nlog.Errorf("转换 %s 到 Gender类型 失败，使用Secure替代", str)
	return GenderSecure
}
